Subject: Re: bug#20466: 25.0.50; REGRESSION in `isearch-mode-map': <backspace> is not translated to DEL

From: Artur Malabarba <[email-masked]>
Date: Thu, 30 Apr 2015 10:30:09 +0100

Looking at the commit message for that change, it points at this bug
report: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=16342

It looks valid to me. Isearch doesn't know where it's being run so it
needs to ensure backspace is bound to the right key. I suppose it
could do some keybind checking and only bind backspace if it wouldn't
already be translated to DEL, but then this reported issue would still
happen on these cases (and it would be even harder for the user to
figure out because it would only happen on some buffers).

2015-04-30 6:19 GMT+01:00 Drew Adams <[email-masked]>:
> This regression was apparently introduced in Emacs 24.4.
>
> (define-key isearch-mode-map (kbd "DEL")
>             (lambda () (interactive) (message "@@@@@@@@@@@@@@@@")))
>
> During Isearch, hit the Backspace key.  `DEL' is not used, so the
> message is not seen.  `isearch-mode-map' shows that `DEL' is correctly
> bound to the above command, but `<backspace>' is bound to
> `isearch-delete-char'.  It is not translated to `DEL', as is the case in
> Emacs generally (still), but it instead now has its own explicit binding
> in `isearch-mode-map'.
>
> Why?  This is an unexpected (and unnecessary?) obstacle for users.
> It is an incompatible change, and I see nothing in NEWS about it.
> Was it an oversight or intentional?
>
> In Emacs prior to 24.4, the message is shown, and `isearch-mode-map'
> shows that `DEL' is bound to the above command and there is no binding
> for `<backspace>'.  Because there is no binding for it, it gets
> translated to `DEL' (as is true in Emacs generally, even in 24.4+).
>
> In GNU Emacs 25.0.50.1 (i686-pc-mingw32)
>  of 2014-10-20 on LEG570
> Bzr revision: 118168 [email-masked]
> Windowing system distributor `Microsoft Corp.', version 6.1.7601
> Configured using:
>  `configure --enable-checking=yes,glyphs CPPFLAGS=-DGLYPH_DEBUG=1'
>
>
>